"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrefetchRoute = PrefetchRoute;

var _react = _interopRequireDefault(require("react"));

var _prefetch = require("./context/prefetch");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class ConnectedPrefetchRoute extends _react.default.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "unregister", void 0);
  }

  componentDidMount() {
    const {
      manager,
      path,
      render
    } = this.props;
    this.unregister = manager.register({
      path,
      render
    });
  }

  componentWillUnmount() {
    if (this.unregister) {
      this.unregister();
    }
  }

  render() {
    return null;
  }

}

function PrefetchRoute(props) {
  return /*#__PURE__*/_react.default.createElement(_prefetch.PrefetchContext.Consumer, null, manager => /*#__PURE__*/_react.default.createElement(ConnectedPrefetchRoute, Object.assign({
    manager: manager
  }, props)));
}