"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrefetchContext = exports.PrefetchManager = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class PrefetchManager {
  constructor(registered) {
    _defineProperty(this, "registered", void 0);

    this.registered = new Set(registered);
  }

  register(registration) {
    this.registered.add(registration);
    return () => this.registered.delete(registration);
  }

}

exports.PrefetchManager = PrefetchManager;

const PrefetchContext = /*#__PURE__*/_react.default.createContext(new PrefetchManager());

exports.PrefetchContext = PrefetchContext;